/*
 * 05/28/2003
 *
 * road.cpp
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "road.h"

// ############
// Classe CRoad
// ############


// ============
// Constructeur
// ============
CRoad::CRoad(int inter1, int inter2, int direction)
{
	m_road[0] = inter1;
	m_road[1] = inter2;
	m_road[2] = direction;

	m_capacity = 0;
	m_stream[0] = 0;
	m_stream[1] = 0;
}


// ====================================
// Change les informations sur la route
// ====================================
void CRoad::SetInfoRoad(int inter1, int inter2, int direction)
{
	m_road[0] = inter1;
	m_road[1] = inter2;
	m_road[2] = direction;
}


// ======================================
// Retourne les informations sur la route
// ======================================
int CRoad::GetInfoRoad(int i)
{
	return m_road[i];
}


// =======================================================
// Retourne la capacit d'une route
// (nombre de voiture quelle peut accueillir dans un sens)
// =======================================================
int CRoad::GetCapacity()
{
	return m_capacity;
}


// =======================================================
// Change la capacit d'une route
// (nombre de voiture quelle peut accueillir dans un sens)
// =======================================================
void CRoad::SetCapacity(int capacity)
{
	m_capacity = capacity;
}


// =======================================
// Change la taille d'un flot des voitures
// =======================================
void CRoad::SetStream(int sens, float stream)
{
	m_stream[sens] = stream;
}


// =========================================
// Retourne la taille d'un flot des voitures
// =========================================
float CRoad::GetStream(int sens)
{
	return m_stream[sens];
}


// =========================================
// Ajoute a la taille d'un flot des voitures
// =========================================
void CRoad::AddStream(int sens, float stream)
{
	m_stream[sens] += stream;
}


// ============================================
// Retranche a la taille d'un flot des voitures
// ============================================
void CRoad::RemoveStream(int sens, float stream)
{
	m_stream[sens] -= stream;
}


// ================================
// Teste si on peut ajouter un flot
// ================================
bool CRoad::IsPossibleAddStream(int sens, float stream)
{
	if (m_capacity == 0) return true;
	if ((m_stream[sens]) >= m_capacity)
		return false;
	else return true;
}


