/*
 * 05/28/2003
 *
 * simtraffic.h
 * Fonctions et constantes principales de l'application
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _SIMTRAFFIC_H
#define _SIMTRAFFIC_H

// ====================
// Inclusions standards
// ====================
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <iostream>
#include <time.h>
#include <GL/glut.h>

using namespace std;

// ==================
// Windows inclusions
// ==================
#ifdef _WIN32
#include <windows.h>
#pragma comment(lib, "opengl32.lib")		// recherche de OpenGL32.lib pendant l'edition de liens
#pragma comment(lib, "glu32.lib")			// recherche de Glu32.lib pendant l'edition de liens
#pragma comment(lib, "glut32.lib")			// recherche de Glut32.lib pendant l'edition de liens
#define WIN32_LEAN_AND_MEAN
#endif

// =================
// Inclusions persos
//==================
#include "global.h"
#include "error.h"
#include "camera.h"
#include "camerafree.h"
#include "cameraiso.h"
#include "camera3person.h"
#include "camerasystem.h"
#include "mouse.h"
#include "timerGLUT.h"
#include "initGLUT.h"
#include "bitmapGL.h"
#include "tga.h"
#include "building.h"
#include "frustum.h"
#include "city.h"
#include "skybox.h"
#include "vehicle.h"

// ============================================
// Caracteristiques de la fenetre et de l'ecran
// ============================================
#define WINDOW_WIDTH 640		// largeur de la fentre
#define WINDOW_HEIGHT 480		// largeur de la fentre
#define	WINDOW_POS_X 100		// position x de la fentre
#define WINDOW_POS_Y 100		// position y de la fentre
#define FULLSCREEN_WIDTH 800	// largeur en mode plein cran
#define FULLSCREEN_HEIGHT 600	// hauteur en mode plein cran
#define FULLSCREEN_DEPTH 16		// bit par pixels en mode plen cran

// ==========
// Prototypes
// ==========

// ========================
// Initialisations diverses
// ========================
void init(void);

// ================================
// Fonction d'affichage de la scene
// ================================
void glutDisplay(void);

// ===========================================================
// Fonction excut lorsque le programme n'a plus rien  faire
// utilisee pour les animations
// ===========================================================
void glutIdle(void);

// ==================================
// Gestion du clavier (touches ascii)
// ==================================
void glutKeyboard(unsigned char key, int x, int y);

// ======================================
// Gestion du clavier (touches non ascii)
// ======================================
void glutSpecialKeys(int key, int x, int y);

// =========================================
// Gestion de la souris (clicks des boutons)
// =========================================
void glutMouse(int button, int state, int x, int y);

// ================================================================
// Gestion des mouvements de la souris lorsqu'un bouton est enfonce
// ================================================================
void glutMotion(int x, int y);


// ==========================================================
// Ajoute un vehicule aleatoirement sur une route de la ville
// ==========================================================
void addVehicle();

// ==============================================
// Supprime un vehicule (le premier de la chaine)
// ==============================================
void delVehicle();


// ===================================
// Menu permettant de choisir la ville
// ===================================
int menuVille();

#endif

