/*
 * 05/28/2003
 *
 * trafficlight.h
 * Represente un feux de signalisation tricolore
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _TRAFFICLIGHT_H
#define _TRAFFICLIGHT_H

#include "object.h"
#include "frustum.h"
#include "global.h"
#include <GL/glut.h>

// Couleur du feux
const int RED = 0;
const int GREEN = 1;
const int ORANGE = 2;

// Temps entre les changements de feux (en milli-secondes)
const int GREEN_TIMEOUT = 7000;
const int ORANGE_TIMEOUT = 1500;
const int RED_TIMEOUT = GREEN_TIMEOUT + ORANGE_TIMEOUT;

// ####################
// Classe CTrafficLight
// ####################
class CTrafficLight : public CObject
{
public:

	// Dessin en cel-shading
	bool static CELSHADING;

	// ======================
	// Constructeur
	// light = couleur du feu
	// ======================
	CTrafficLight(int light);

	// ===========
	// Destructeur
	// ===========
	~CTrafficLight();

	// ==============
	// Dessine le feu
	// ==============
	void Draw(CFrustum * frustum);

	// ===========================================
	// Retourne la couleur du feu RED GREEN ORANGE
	// ===========================================
	int GetLight();

	// =================================
	// Teste si le feux doit etre change
	// =================================
	void Change(int elapsedTime);

private:

	// Temps restant avant le changement de couleur du feu (en millisecondes)
	int m_time;

	// Couleur du feu
	int m_light;
};

#endif 
